//+------------------------------------------------------------------+
//|                                                   nck-v1.mq4 |
//|                                   Copyright  2008, MQLCoder.com |
//|                                          http://www.mqlcoder.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MQLCoder.com"
#property link      "http://www.mqlcoder.com"

extern double lot=0.1;
extern int SL=40;
extern int TP=40;
extern int BE=0;
extern int TS=0;
extern int Start_Hour=8;
extern int End_Hour=20;

int magic=73267;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int start()
  {
  
    double myPoint=Point;
    if (Digits==3 || Digits==5) myPoint=Point*10;
    
    double goldm1_buy=iCustom(Symbol(),0,"goldminer1",1,1);
    double goldm1_sell=iCustom(Symbol(),0,"goldminer1",0,1);
    double goldm2_buy=iCustom(Symbol(),0,"goldminer2",0,1);
    double goldm2_sell=iCustom(Symbol(),0,"goldminer2",1,1);
    
    int y,cb=0,cs=0;

    for (y = 0; y < OrdersTotal(); y++)
    {
      OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
      if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_BUY)) {
        cb++;
        
        if (BE>0 && OrderStopLoss()<OrderOpenPrice() && OrderClosePrice()-OrderOpenPrice()>=BE*myPoint) {
          OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+myPoint,OrderTakeProfit(),0);
          return;
        }

        if(TS>0)  
        {                 
          if(Bid-OrderOpenPrice()>myPoint*TS)
          {
            if(OrderStopLoss()<Bid-myPoint*TS)
            {
              OrderModify(OrderTicket(),OrderOpenPrice(),Bid-myPoint*TS,OrderTakeProfit(),0,Green);
              return(0);
            }
          }
        }
      }

     if ((OrderMagicNumber()==magic) && (OrderSymbol()==Symbol()) && (OrderType()==OP_SELL)) {
        cs++;

        if (BE>0 && OrderStopLoss()>OrderOpenPrice() && OrderOpenPrice()-OrderClosePrice()>=BE*myPoint) {
          OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-myPoint,OrderTakeProfit(),0);
          return;
        }

        if(TS>0)  
        {                 
          if((OrderOpenPrice()-Ask)>(myPoint*TS))
          {
            if((OrderStopLoss()>(Ask+myPoint*TS)) || (OrderStopLoss()==0))
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask+myPoint*TS,OrderTakeProfit(),0,Red);
               return(0);
            }
          }
        }
     }

    }
    
    
    bool b=goldm1_buy>0 && goldm2_buy>0 && Hour()>=Start_Hour && Hour()<End_Hour && cb==0 && cs==0;
    bool s=goldm1_sell>0 && goldm2_sell>0 && Hour()>=Start_Hour && Hour()<End_Hour && cb==0 && cs==0;
    
    
    if (b) {
      OrderSend(Symbol(),OP_BUY,lot,Ask,1,Ask-SL*myPoint,Ask+TP*myPoint,NULL,magic);
      return;
    }
    
    if (s) {
      OrderSend(Symbol(),OP_SELL,lot,Bid,1,Bid+SL*myPoint,Bid-TP*myPoint,NULL,magic);
      return;
    }
   
    return(0);
  }
//+------------------------------------------------------------------+